import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/fetchData/page.ts";
import { HashError, hashObject } from '@contentlayer/utils';
import { pipe, T } from '@contentlayer/utils/effect';
import { UnknownNotionError } from '../errors.js';
import { getFieldFunctions } from '../mapping/index.js';
export const makeCacheItem = ({ client, page, renderer, databaseTypeDef, documentTypeDef, options, ...rest }) => T.gen(function* ($) {
    const { typeFieldName } = options.fieldOptions;
    const docValues = yield* $(T.forEachParDict_(documentTypeDef.fieldDefs, {
        mapValue: (fieldDef) => {
            if (fieldDef.name === 'content')
                return getPageContent({ page, client, renderer });
            const databaseFieldTypeDef = databaseTypeDef.fields?.find((field) => field.key === fieldDef.propertyKey);
            return getDataForFieldDef({
                fieldDef,
                property: page.properties[fieldDef.propertyKey],
                renderer,
                databaseFieldTypeDef,
                options,
                client,
                page,
                databaseTypeDef,
                documentTypeDef,
                ...rest,
            });
        },
        mapKey: (fieldDef) => T.succeed(fieldDef.name, fileName_1 + ":58:40"),
    }), fileName_1 + ":38:31");
    const document = {
        ...docValues,
        [typeFieldName]: documentTypeDef.name,
        _id: page.id,
        _raw: {},
    };
    const documentHash = yield* $(hashObject(document), fileName_1 + ":69:34");
    return { document, documentHash, hasWarnings: false, documentTypeName: documentTypeDef.name };
}, fileName_1 + ":35:8");
const getDataForFieldDef = ({ property, ...rest }) => (T.mapError_(T.gen(function* () {
    if (!property)
        return;
    const functions = getFieldFunctions(property.type);
    if (!functions)
        return;
    return functions.getFieldData({ property, ...rest });
}, fileName_1 + ":81:10"), (error) => new HashError({ error }), fileName_1 + ":89:15"));
const getPageContent = ({ page, renderer, }) => (T.mapError_(T.tryPromise(() => renderer.renderBlock(page.id), fileName_1 + ":101:17"), (error) => new UnknownNotionError({ error }), fileName_1 + ":102:15"));
//# sourceMappingURL=page.js.map