import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/schema/provideSchema.ts";
import * as core from '@contentlayer/core';
import * as utils from '@contentlayer/utils';
import { OT, pipe, T } from '@contentlayer/utils/effect';
import { provideDatabaseSchema } from './provideDatabaseSchema.js';
export const provideSchema = ({ client, databaseTypeDefs, ...rest }) => (T.mapError_(OT.withSpan('@contentlayer/source-notion/schema:provideSchema')(
// Generate hash using Schema definition and include it
T.chain_(
// Generates Schema definition without hash
T.map_(T.gen(function* ($) {
    const documentTypeDefMap = {};
    for (const databaseTypeDef of databaseTypeDefs) {
        documentTypeDefMap[databaseTypeDef.name] = yield* $(provideDatabaseSchema({ client, databaseTypeDef, databaseTypeDefs, documentTypeDefMap, ...rest }), fileName_1 + ":26:60");
    }
    return documentTypeDefMap;
}, fileName_1 + ":22:10"), (documentTypeDefMap) => ({
    documentTypeDefMap,
    nestedTypeDefMap: {},
}), fileName_1 + ":35:10"), (schemaDef) => (T.tap_(T.map_(utils.hashObject(schemaDef), (hash) => ({
    ...schemaDef,
    hash,
}), fileName_1 + ":46:14"), (schemaDef) => T.succeed(core.validateSchema(schemaDef), fileName_1 + ":52:39"), fileName_1 + ":52:14")), fileName_1 + ":43:12")), (error) => new core.SourceProvideSchemaError({ error }), fileName_1 + ":58:15"));
//# sourceMappingURL=provideSchema.js.map